Module | Paperclip::ClassMethods
In: | vendor/plugins/paperclip/lib/paperclip.rb

### Methods

attachment_definitions has_attached_file validates_attachment_content_type validates_attachment_presence validates_attachment_size validates_attachment_thumbnails

### Included Modules

InstanceMethods

### Public Instance methods

attachment_definitions()

Returns the attachment definitions defined by each call to has_attached_file.

[Source]

         # File vendor/plugins/paperclip/lib/paperclip.rb, line 279
    279:     def attachment_definitions
    280:       read_inheritable_attribute(:attachment_definitions)
    281:     end

has_attached_file(name, options = {})

`has_attached_file` gives the class it is called on an attribute that maps to a file. This is typically a file stored somewhere on the filesystem and has been uploaded by a user. The attribute returns a Paperclip::Attachment object which handles the management of that file. The intent is to make the attachment as much like a normal attribute. The thumbnails will be created when the new file is assigned, but they will not be saved until `save` is called on the record. Likewise, if the attribute is set to `nil` is called on it, the attachment will not be deleted until `save` is called. See the Paperclip::Attachment documentation for more specifics. There are a number of options you can set to change the behavior of a Paperclip attachment:

- `url`: The full URL of where the attachment is publically accessible. This can just as easily point to a directory served directly through Apache as it can to an action that can control permissions. You can specify the full domain and path, but usually just an absolute path is sufficient. The leading slash must be included manually for absolute paths. The default value is "/system/:attachment/:id/:style/:basename.:extension". See Paperclip::Attachment#interpolate for more information on variable interpolaton.

        :url => "/:class/:attachment/:id/:style_:basename.:extension"
        :url => "http://some.other.host/stuff/:class/:id_:extension"

- `default_url`: The URL that will be returned if there is no attachment assigned. This field is interpolated just as the url is. The default value is "/:attachment/:style/missing.png"

        has_attached_file :avatar, :default_url => "/images/default_:style_avatar.png"
        User.new.avatar_url(:small) # => "/images/default_small_avatar.png"

- `styles`: A hash of thumbnail styles and their geometries. You can find more about geometry strings at the ImageMagick website (www.imagemagick.org/script/command-line-options.php#resize). Paperclip also adds the "#" option (e.g. "50x50#"), which will resize the image to fit maximally inside the dimensions and then crop the rest off (weighted at the center). The default value is to generate no thumbnails.
- `default_style`: The thumbnail style that will be used by default URLs. Defaults to `original`.

        has_attached_file :avatar, :styles => { :normal => "100x100#" },
                          :default_style => :normal
        user.avatar.url # => "/avatars/23/normal_me.png"

- `whiny_thumbnails`: Will raise an error if Paperclip cannot post_process an uploaded file due to a command line error. This will override the global setting for this attachment. Defaults to true.
- `convert_options`: When creating thumbnails, use this free-form options field to pass in various convert command options. Typical options are "-strip" to remove all Exif data from the image (save space for thumbnails and avatars) or "-depth 8" to specify the bit depth of the resulting conversion. See ImageMagick convert documentation for more options: (www.imagemagick.org/script/convert.php) Note that this option takes a hash of options, each of which correspond to the style of thumbnail being generated. You can also specify :all as a key, which will apply to all of the thumbnails being generated. If you specify options for the :original, it would be best if you did not specify destructive options, as the intent of keeping the original around is to regenerate all the thumbnails when requirements change.

        has_attached_file :avatar, :styles => { :large => "300x300", :negative => "100x100" }
                                   :convert_options => {
                                     :all => "-strip",
                                     :negative => "-negate"
                                   }

- `storage`: Chooses the storage backend where the files will be stored. The current choices are :filesystem and :s3. The default is :filesystem. Make sure you read the documentation for Paperclip::Storage::Filesystem and Paperclip::Storage::S3 for backend-specific options.

[Source]

         # File vendor/plugins/paperclip/lib/paperclip.rb, line 186
    186:     def has_attached_file name, options = {}
    187:       include InstanceMethods
    188:
    189:       write_inheritable_attribute(:attachment_definitions, {}) if attachment_definitions.nil?
    190:       attachment_definitions[name] = {:validations => {}}.merge(options)
    191:
    192:       after_save :save_attached_files
    193:       before_destroy :destroy_attached_files
    194:
    195:       define_callbacks :before_post_process, :after_post_process
    196:       define_callbacks "before_#{name}_post_process""before_#{name}_post_process", "after_#{name}_post_process""after_#{name}_post_process"
    197:
    198:       define_method name do |*args|
    199:         a = attachment_for(name)
    200:         (args.length > 0) ? a.to_s(args.first) : a
    201:       end
    202:
    203:       define_method "#{name}=" do |file|
    204:         attachment_for(name).assign(file)
    205:       end
    206:
    207:       define_method "#{name}?" do
    208:         attachment_for(name).file?
    209:       end
    210:
    211:       validates_each(name) do |record, attr, value|
    212:         attachment = record.attachment_for(name)
    213:         attachment.send(:flush_errors) unless attachment.valid?
    214:       end
    215:     end

validates_attachment_content_type(name, options = {})

Places ActiveRecord-style validations on the content type of the file assigned. The possible options are:

- `content_type`: Allowed content types. Can be a single content type or an array. Each type can be a String or a Regexp. It should be noted that Internet Explorer upload files with content_types that you may not expect. For example, JPEG images are given image/pjpeg and PNGs are image/x-png, so keep that in mind when determining how you match. Allows all by default.
- `message`: The message to display when the uploaded file has an invalid content type.

NOTE: If you do not specify an [attachment]_content_type field on your model, content_type validation will work _ONLY upon assignment_ and re-validation after the instance has been reloaded will always succeed.

[Source]

         # File vendor/plugins/paperclip/lib/paperclip.rb, line 262
    262:     def validates_attachment_content_type name, options = {}
    263:       attachment_definitions[name][:validations][:content_type] = lambda do |attachment, instance|
    264:         valid_types = [options[:content_type]].flatten
    265:
    266:         unless attachment.original_filename.blank?
    267:           unless valid_types.blank?
    268:             content_type = attachment.instance_read(:content_type)
    269:             unless valid_types.any?{|t| content_type.nil? || t === content_type }
    270:               options[:message] || "is not one of the allowed file types."
    271:             end
    272:           end
    273:         end
    274:       end
    275:     end

validates_attachment_presence(name, options = {})

Places ActiveRecord-style validations on the presence of a file.

[Source]

         # File vendor/plugins/paperclip/lib/paperclip.rb, line 242
    242:     def validates_attachment_presence name, options = {}
    243:       message = options[:message] || "must be set."
    244:       attachment_definitions[name][:validations][:presence] = lambda do |attachment, instance|
    245:         message unless attachment.file?
    246:       end
    247:     end

validates_attachment_size(name, options = {})

Places ActiveRecord-style validations on the size of the file assigned. The possible options are:

- `in`: a Range of bytes (i.e. +1..1.megabyte+),
- `less_than`: equivalent to :in => 0..options[:less_than]
- `greater_than`: equivalent to :in => options[:greater_than]..Infinity
- `message`: error message to display, use :min and :max as replacements

[Source]

         # File vendor/plugins/paperclip/lib/paperclip.rb, line 223
    223:     def validates_attachment_size name, options = {}
    224:       min     = options[:greater_than] || (options[:in] && options[:in].first) || 0
    225:       max     = options[:less_than]    || (options[:in] && options[:in].last)  || (1.0/0)
    226:       range   = (min..max)
    227:       message = options[:message] || "file size must be between :min and :max bytes."
    228:
    229:       attachment_definitions[name][:validations][:size] = lambda do |attachment, instance|
    230:         if attachment.file? && !range.include?(attachment.size.to_i)
    231:           message.gsub(/:min/, min.to_s).gsub(/:max/, max.to_s)
    232:         end
    233:       end
    234:     end

validates_attachment_thumbnails(name, options = {})

Adds errors if thumbnail creation fails. The same as specifying :whiny_thumbnails => true.

[Source]

         # File vendor/plugins/paperclip/lib/paperclip.rb, line 237
    237:     def validates_attachment_thumbnails name, options = {}
    238:       attachment_definitions[name][:whiny_thumbnails] = true
    239:     end

[Validate]